#!/usr/bin/env python

import commands
import pygtk
import sys
pygtk.require('2.0')

import gnomeapplet
import gtk, os
import subprocess

num = 0
button = gtk.Button()

display = 0

full = 0

def factory(applet, iid):
        global button
        button.set_relief(gtk.RELIEF_NONE)
        image = gtk.Image()
        image.set_from_file("/usr/share/icons/ubuntuwintv.png")
        button.set_image(image)
        button.connect("button_press_event", showMenu, applet)
        applet.add(button)
        applet.show_all()
        return True

def on_button_clicked(button, *args):
        global num
        if (num%2==0):
                image = gtk.Image()
                image.set_from_file("/usr/share/icons/gnome/48x48/devices/gnome-dev-floppy-red.png")
                button.set_image(image)
                button.set_label("")
        else:
                image = gtk.Image()
                image.set_from_file("/usr/share/icons/gnome/48x48/devices/gnome-dev-floppy-green.png")
                button.set_image(image)
                button.set_label("")
        num=num+1

def about(*arguments, **keywords):
	subprocess.Popen("zenity --info --title='About UBUNTUWIN TV ' --text='@2009 Palumbo Roberto.\nE-Mail: palumborobertomail@gmail.com\nWebsite: ubuntuwin.altervista.org'",shell=True)
	
def create_menu(applet):
	propxml="""
			<popup name="button3">
			<menuitem name="bbb" verb="About" label="About"/>
			<menuitem name="bbb" verb="About" label="Aggiornamenti su: ubuntuwin.altervista.org"/>
			</popup>"""
	verbs = [("About", about)]
	applet.setup_menu(propxml, verbs, None)

def tog(widget,data):
	global display,full
	if data=='DISPLAY':
		if widget.get_active()==True:
			display=1
		else:
			display=0
	if data=='FULL':
		if widget.get_active()==True:
			full=1
		else:
			full=0

def salva(self):
	pass

def config(self,parametro):
	global display,full
	self.win = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.win.set_position(gtk.WIN_POS_CENTER)
	self.win.set_default_size(250,250)
	self.win.set_title('UbuntuWin TV - Configuration')
	self.title = 'App'
	self.button_r1 = gtk.CheckButton('Use secondary X Display')
	self.button_r1.connect('toggled',tog,'DISPLAY')
	self.button_r2 = gtk.CheckButton('Fullscreen')
	self.button_r2.connect('toggled',tog,'FULL')

	if (display==1):
		self.button_r1.set_active(True)
	if (full==1):
		self.button_r2.set_active(True)
	#self.savesetting = gtk.Button('Save configuration')
	#self.savesetting.connect('clicked',salva)
	
	self.vbox = gtk.VBox(False,3)
	self.vbox.pack_start(self.button_r1,False,False,0)
	self.vbox.pack_start(self.button_r2,False,False,0)

	#self.vbox.pack_start(self.savesetting,False,False,0)
	
	self.win.add(self.vbox)
	self.win.show_all()
		
def showMenu(widget, event, applet):
	if event.button == 1:
		menu = gtk.Menu()
		for l in range(1,3):
			if l==1 : titolo = "TV"
			if l==2 : titolo = "RADIO"
			top = gtk.ImageMenuItem(titolo, True)
			top.show()
			f = open ('/etc/canali'+repr(l)+'.txt','r')
			canali = f.readlines()
			f.close()
			i = 1
			arr = []
			for str in canali:
				(nome,indirizzo)=str.split('#')
				arr.append((nome,indirizzo))
			#arr.sort()
			menuitem = gtk.Menu()

			for menuItem in arr:
				item = gtk.ImageMenuItem(menuItem[0], True)
				item.show()
				item.connect( "activate", scegli,menuItem[1])
				menuitem.add(item)
			top.set_submenu(menuitem)
			menu.add(top)
		cfg = gtk.ImageMenuItem("Config",True)
		cfg.show()
		cfg.connect("activate",config,"aaa")
		menu.add(cfg)
		menu.popup( None, None, None, event.button, event.time )
	if event.button == 3:
		widget.emit_stop_by_name("button_press_event")
		create_menu(applet)
		
def scegli(widget,parametro):
	global button
	global num, display, full
	num=num+1
	os.system("killall vlc")
	if (full==1):
		fullscreen=" -f "
	else:
		fullscreen=""
	print fullscreen
	if (display==0):
		subprocess.Popen("vlc "+fullscreen+parametro,shell=True)
	else:
		subprocess.Popen("DISPLAY=:0.1 vlc "+fullscreen+parametro+fullscreen,shell=True)
		

def showAboutDialog(*arguments, **keywords):
        pass

if len(sys.argv) == 2:
        if sys.argv[1] == "run-in-window":
				mainWindow = gtk.Window(gtk.WINDOW_TOPLEVEL)
				mainWindow.set_title("UBUNTUWIN TV")
				mainWindow.connect("destroy", gtk.main_quit)
				applet = gnomeapplet.Applet()
				factory(applet, None)
				applet.reparent(mainWindow)
				mainWindow.show_all()
				gtk.main()
				sys.exit()

if __name__ == '__main__':
		print "Starting UbuntuwinTV"
		gnomeapplet.bonobo_factory("OAFIID:UbuntuwinTV_Factory", gnomeapplet.Applet.__gtype__, "UbuntuwinTV", "1.0", factory)
